// Forza Ferrari!
#include <bits/stdc++.h>
using namespace std;

struct Fenwick {
  int size;
  vector<int> bit;

  Fenwick(int n) : size(n), bit(n + 1) {}

  void update(int i, int value) {
    for (++i; i <= size; i += i & -i) {
      bit[i] += value;
    }
  }

  int query(int r) {
    int ans = 0;
    for (; r > 0; r -= r & -r) {
      ans += bit[r];
    }
    return ans;
  }
};

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n;
  cin >> n;
  vector<int> a(n), b(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i] >> b[i];
  }
  vector<int> p(n);
  for (int &value : p) {
    cin >> value;
  }
  long long actual = 0;
  long long ans = 0;
  vector<long long> suf(n + 1);
  for (int i = n - 1; i >= 0; i--) {
    suf[i] = suf[i + 1] + b[i];
  }
  using Node = pair<long long, int>;
  priority_queue<Node, vector<Node>, greater<Node>> pq;
  int cnt = 0;
  for (int i = 1; i <= n; i++) {
    ans += a[i - 1];
    while (!pq.empty() && pq.top().first < suf[i]) {
      ans -= pq.top().first * pq.top().second;
      cnt -= pq.top().second;
      pq.pop();
    }
    if (suf[i] > 0) {
      pq.emplace(suf[i], i - cnt);
      ans += 1LL * (i - cnt) * suf[i];
      cnt = i;
    }
    actual = max(actual, ans - cnt * suf[i]);
  }
  cout << actual << "\n";
}
